package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.ZCMX;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class ZCMXSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<ZCMX> selectCond;
	private JSONObject customsearchval;
	public ZCMXSearchFilter(){
		this.page =new Page<ZCMX>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<ZCMX>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_xmid_eq;

	public void setN_xmid_eq(String n_xmid_eq) {
        this.n_xmid_eq = n_xmid_eq;
        if(!StringUtils.isEmpty(this.n_xmid_eq)){
            this.selectCond.eq("xmid", n_xmid_eq);
        }
    }
	private String n_zcmxname_like;

	public void setN_zcmxname_like(String n_zcmxname_like) {
        this.n_zcmxname_like = n_zcmxname_like;
        if(!StringUtils.isEmpty(this.n_zcmxname_like)){
            this.selectCond.like("zcmxname", n_zcmxname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_ZCMX_XM_XMID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_xmid_eq("NA");
			}
			else{
				this.setN_xmid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("zcmxname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}